cc.Class({
    extends: cc.Component,

    properties: {
        //net: cc.Prefab,
        velocity: {
            default: cc.Vec2.ZERO,
            tooltip: 'Local transition per second'
        },
        dir: {
            default: cc.Vec2.ONE,
            tooltip: 'Local direction'
        },
        col: {
            default: 0,
            tooltip: 'collision flag'
        },
        tempPos: {
            default: cc.Vec2.ONE,
            tooltip: 'Temp Position'
        },
        speed: 500,
        screenSize: 1,
        top: 1,
        bottom: 1,
        left: 1,
        right: 1,
        owner: {
            default: 0,
            visible: false
        },
    },

    onLoad () {
        this.screenSize = cc.Canvas.instance.node.getContentSize();
        this.top = (this.screenSize.height / 2);
        this.bottom = -this.top;
        this.left = (-this.screenSize.width / 2);
        this.right = -this.left;
    },

    update (dt) {
        // do move by self direction.
        this.tempPos = this.node.position.clone();
        this.tempPos.addSelf(this.velocity.mul(dt));
        this.node.position = this.tempPos.clone();
    },

    lateUpdate () {
        this.detectBoundary();
    },

    detectBoundary () {
        this.tempPos = this.node.position.clone();
        let v1 = this.dir.clone();

        // detect boundary and do bouncing
        if(this.tempPos.y >= this.top){
            if(this.col !== 4){
                v1.y = (-1) * v1.y;
                this.dir.y = v1.y;
                this.col = 4;
                this.velocity = cc.v2((v1.x*this.speed), (v1.y*this.speed));
                //cc.log("Bullet touch Top, " + pos.x + "," + pos.y);
            }

            //this.node.active = false;
            //cc.remove(this);
        }

        if(this.tempPos.y <= this.bottom){
            if(this.col !== 2){
                v1.y = (-1) * v1.y;
                this.dir.y = v1.y;
                this.col = 2;
                this.velocity = cc.v2((v1.x*this.speed), (v1.y*this.speed));
            }
        }


        if(this.tempPos.x <= this.left){
            if(this.col !== 1){
                v1.x = (-1) * v1.x;
                this.dir.x = v1.x;
                this.col = 1;
                this.velocity = cc.v2((v1.x*this.speed), (v1.y*this.speed));
            }
        }

        if(this.tempPos.x >= this.right){
            if(this.col !== 3){
                v1.x = (-1) * v1.x;
                this.dir.x = v1.x;
                this.col = 3;
                this.velocity = cc.v2((v1.x*this.speed), (v1.y*this.speed));
            }
        }

        // update rotation
        let degree = Math.atan2(this.dir.y, this.dir.x);
        degree = degree * 180 / Math.PI;
        this.node.rotation = 90 - degree;
    },

    onCollisionEnter (other) {
        if (other.node.group === 'fish') {
        	this.node.active = false;
            //let netNode = cc.instantiate(this.net);
            //netNode.position = this.node.position.clone();
            //netNode.parent = G.game.sfx;
            //cc.remove(this);
            this.node.destroy();
        }
        else if (other.node.group === 'outer bound') {
            cc.log("WTF**********bullet out of bounds, " + this.node.position);
            //G.game.obCount++;
            //G.game.updateObCountText();
            this.node.active = false;
            this.node.destroy();
        }

        // for AI's bullet limit
        if(G.game.isLocalPos != this.owner){
            G.game.bulletCount--;
        }
    }
});
