// setup engine and editor
cc.view.enableAntiAlias(true);
//cc.audioEngine.setMaxWebAudioSize(100);
//cc.game.setFrameRate(30);
var randFloor = require('Utils').randFloor;

cc.Class({
    extends: cc.Component,

    properties: {
        spGroups: {
            default: [],
            type: [cc.Vec2]
        },
        tpGroups: {
            default: [],
            type: [cc.Node]
        },
        seats: {
            default: [],
            type: [cc.Node]
        },
        coinPrefab: {
            default: [],
            type: [cc.Prefab],
        },
        bgPrefab: {
            default: [],
            type: [cc.Prefab],
        },
        seawavePrefab: {
            default: [],
            type: [cc.Prefab],
        },
        cannonPrefab: {
            default: null,
            type: cc.Prefab,
        },
        waitPrefab: {
            default: null,
            type: cc.Prefab,
        },
        sfx: cc.Node,
        bg: cc.Node,
        hitFishText: {
            default: null,
            type: cc.Label
        },
        fishCountText: {
            default: null,
            type: cc.Label
        },
        fpsText: {
            default: null,
            type: cc.RichText
        },
        talkText: {
            default: null,
            type: cc.RichText
        },
        wtfCountText: {
            default: null,
            type: cc.Label
        },
        weapons: {
            default: [],
            type: [cc.Node],
            visible: false
        },
        coins: {
            default: [],
            type: [cc.Node],
            visible: false
        },
        screenSize: {
            default: cc.Vec2.ONE,
            visible: false
        },
        bulletLimit: {
            default: 20,
            visible: false
        },
        fishCount_com: {
            default: 0,
            visible: false
        },
        bossCount: {
            default: 0,
            visible: false
        },
        fishCount_seq: {
            default: 0,
            visible: false
        },
        obCount: {
            default: 0,
            visible: false
        },
        spGap: {
            default: 50,
            visible: false
        },
        tpGap: {
            default: 600,
            visible: false
        },
        hitFish: {
            default: 0,
            visible: false
        },
        hitSeqFish: {
            default: 0,
            visible: false
        },
        hitBoss: {
            default: 0,
            visible: false
        },
        step1: {
            default: 20,
            visible: false
        },
        step2: {
            default: 60,
            visible: false
        },
        bulletCount: {
            default: 0,
            visible: false
        },
        isLocalPos: {
            default: 0,
            visible: false
        },
        curScene: {
            default: 0,
            visible: false
        },
        fpsCount: {
            default: 0,
            visible: false
        },
        playCoinFlag: {
            default: false,
            visible: false
        },
        wtfCount: {
            default: 0,
            visible: false
        },
        wtfCount2: {
            default: 0,
            visible: false
        },
        configReady: {
            default: false,
            visible: false
        },
        firstIn: {
            default: false,
            visible: false
        },
        talkFlag: {
            default: false,
            visible: false
        },
    },

    // use this for initialization
    onLoad () {
        let screenSize = cc.Canvas.instance.node.getContentSize();

        for(let i=0; i<this.tpGroups.length; i++){
           this.tpGroups[i] = new cc.Node(); 
        }

        G.game = this;
        this.state = G.States.Playing;
        this.screenSize.x = screenSize.width;
        this.screenSize.y = screenSize.height;

        cc.director.getCollisionManager().enabled = true;

        // WTF, disabled variablies need to set default value here
        this.bulletCount = 0;
        this.curScene = 0;
        this.curBgm = -1;
        this.configReady = false;
        this.firstIn = false;

        // init weapons
        this.weapons[0] = null;
        this.weapons[1] = null;
        this.weapons[2] = null;
        this.weapons[3] = null;
    },

    changeState (newState) {
        this.state = newState;
        switch (newState) {
            case G.States.Playing:
                break;
            case G.States.Paused:
                break;
            case G.States.Stopped:
                break;
        }
    },

    updateHitFishCountText () {
        //cc.log("updateFishCountText, " + this.hitFish);
        
        if(this.hitBoss > 0){
            this.hitBoss = 0;
            this.hitFish = 0;
            this.bossCount = 0;
            this.hitSeqFish = 0;
        }
    },

    playSeaWave(){
        let randIndex = 0;

        if(this.seawavePrefab.length > 1){
            //randIndex = randFloor(0, (this.seawavePrefab.length-1));
            randIndex = randFloor(0, 100);
            randIndex = randIndex%(this.seawavePrefab.length);
        }

        let seawaveNode = cc.instantiate(this.seawavePrefab[randIndex]);
        seawaveNode.parent = this.sfx;

        // WTF, flash frame
        for(let i=0; i<seawaveNode.children.length; i++){
            seawaveNode.children[i].active = true;
        }

        seawaveNode.active = true;
    },

    onBossDead(){
    },

    updateFishCountText () {
        //this.fishCountText.string = this.fishCount_com + ", " + this.fishCount_seq;
    },

    updateObCountText () {
        //this.obCountText.string = this.obCount;
    },

    update (dt) {
        // WTF, cocos is not implement "start" state
        if(this.firstIn == false && this.configReady == true){
            // load first background prefab
            this.loadScene();
            this.firstIn = true;
        }

        this.fpsCount++;
/*
        if(this.fpsCount > 10){
            let tempNum = Math.floor(1/dt);

            if(tempNum < 30){
                this.fpsText.string = "<color=#ff0000>" + tempNum + "</c>";
            }
            else{
                this.fpsText.string = "<color=#ffffff>" + tempNum + "</c>";
            }

            this.wtfCountText.string = this.wtfCount;

            this.fpsCount = 0;
        }
*/
    },

    createPlayer (position, islocal, type, point) {
        let playerNode = cc.instantiate(this.cannonPrefab);
        let playerComp = playerNode.getComponent('Player');
        let weaponNode = null;
        let weaponComp = null;
        
        for(let i=0; i<playerNode.children.length; i++){
            //cc.log("Children, " + playerNode.children[i]);
            if(playerNode.children[i].name == "cannon_root"){
                //cc.log("Children, Got it");
                this.weapons[position] = weaponNode = playerNode.children[i];
                weaponComp = weaponNode.getComponent('Weapon');
                break;
            }
        }

        //cc.log("Game:createPlayer, " + position + ", " + islocal);
        
        switch(position){
            case 2:
            case 3:
                playerNode.rotation = 180;
                weaponComp.isReverse = true;
                break;
            default:
                break;
        }

        playerNode.parent = this.seats[position];
        weaponComp.seatNode = this.seats[position];
        weaponComp.seatIndex = position;
        weaponComp.point = point;

        if(islocal == true){
            playerComp.isLocal = true;
            weaponComp.isLocal = true;
            this.isLocalPos = position;
            //cc.log("Game:createPlayer, " + position + ", " + islocal);
        }
        else{
            if(type > 1){
                weaponComp.aiType = type;
            }
            else{
                weaponComp.aiType = 1;
            }
        }

        playerNode.active = true;
    },

    createWaitPlayer (position) {
        //let playerNode = cc.instantiate(this.waitPrefab);
        //playerNode.parent = this.seats[position];
        //playerNode.active = true;
    },

    createCoin (position, count, target) {
        let coinNode = null;
        let coinComp = null;
        let tempX = 0;
        let tempY = 0;

        for(let i=0; i<count; i++){
            if(this.isLocalPos == (target-1)){
                coinNode = cc.instantiate(this.coinPrefab[0]);
            }
            else{
                coinNode = cc.instantiate(this.coinPrefab[1]);
            }

            coinComp = coinNode.getComponent('Coin');
            coinNode.parent = this.sfx;

            coinComp.target = this.seats[(target-1)];
            coinComp.owner = target;    // target=1~4

            tempX = randFloor(0, 9);
            tempY = randFloor(0, 9);
            position.x += tempX;
            position.y += tempY;
            coinComp.node.position = position;

            //coinComp.velocity.x = randFloor(100, 500);
            //coinComp.velocity.y = randFloor(100, 500);
            //coinComp.velocity.x = 10;
            //coinComp.velocity.y = 10;

            if(tempX >=5){
                position.x -= randFloor(0, 100);
            }
            else{
                position.x += randFloor(0, 100);
            }

            if(tempY >=5){
                position.y -= randFloor(0, 100);
            }
            else{
                position.y += randFloor(0, 100);
            }

            this.coins[i] = coinNode;
        }

        this.playCoin ();
    },

    nextScene () {
        this.curScene++;

        if(this.curScene >= this.bgPrefab.length){
            this.curScene = 0;
        }

        if(this.bg.children.length > 0){
            this.bg.children[0].destroy();
        }

        //this.schedule(this.loadScene, 0.05, 1);
        this.loadScene();
    },

    loadScene () {
        let bgNode = cc.instantiate(this.bgPrefab[this.curScene]);
        bgNode.parent = this.bg;
    },

    playCoin () {
        //let coinNode = null;//cc.instantiate(this.coinPrefab);
        //let coinComp = null;//coinNode.getComponent('Coin');
        let i = 0;
        for(let i=0; i<this.coins.length; i++){
            if(this.coins[i].active == false){
            this.coins[i].active = true;
            break;
            }
        }

        //this.unschedule(this.playCoin);
            //this.coins[0].active = true;
            //cc.Array.removeAt(this.coins, 0);
        if(i < this.coins.length){
            //cc.log("coin length, " + this.coins.length);
            if(this.playCoinFlag == false){
                this.schedule(this.playCoin, 0.05);
                this.playCoinFlag = true;
            }
        }
        else if(this.playCoinFlag == true){
            this.unschedule(this.playCoin);
            this.playCoinFlag = false;
        }
    },

    AddCoin: function(pos, val=1) {
        (this.weapons[pos].getComponent('Weapon')).AddPoint(val);
    },

    SetTalkStr: function(val) {
        this.talkText.string = "<color=#ffffff>" + val + "</c>";

        if(this.talkFlag == false){
            this.schedule(this.onTalkTimer, 3);
            this.talkFlag = true;
        }
        else{
            this.unschedule(this.onTalkTimer);
            this.schedule(this.onTalkTimer, 3);
        }
    },
    onTalkTimer () {
        this.unschedule(this.onTalkTimer);
        this.talkFlag = false;
        this.talkText.string = "";
    },
});
