var randFloor = require('Utils').randFloor;
//var Globals = require('./Game');

cc.Class({
    extends: cc.Component,

    properties: {
        interval: 1,
    },

    onEnable () {
        // todo: use counter to limit fish type and generate rate.
        this.schedule(this.addSpawnCounter, this.interval);

        // load and parse global config
        let url = cc.url.raw( 'resources/external/config.json' ); 
            cc.loader.load( url, function(err, res){
            if(err){
                cc.log("err= " + err);
            }
            else{
                //cc.log("1p = " + res["1p"].state + ", " + res["1p"].islocal);
                //cc.log("2p = " + res["2p"].state + ", " + res["2p"].islocal);
                //cc.log("3p = " + res["3p"].state + ", " + res["3p"].islocal);
                //cc.log("4p = " + res["4p"].state + ", " + res["4p"].islocal);
               
                let state = 0;
                let isLocal = false;
                let point = 0;
               
                // create player by config
                for(let i=0; i<G.game.seats.length; i++){
                    switch(i){
                        case 0:
                            state = res["1p"].state;
                            isLocal = res["1p"].islocal;
                            point = res["1p"].point;

                            if(state >= 1){
                                G.game.createPlayer(i, isLocal, state, point);
                            }
                            else{
                                G.game.createWaitPlayer(i);
                            }
                            break;
                        case 1:
                            state = res["2p"].state;
                            isLocal = res["2p"].islocal;
                            point = res["2p"].point;

                            if(state >= 1){
                                G.game.createPlayer(i, isLocal, state, point);
                            }
                            else{
                                G.game.createWaitPlayer(i);
                            }
                            break;
                        case 2:
                            state = res["3p"].state;
                            isLocal = res["3p"].islocal;
                            point = res["3p"].point;

                            if(state >= 1){
                                G.game.createPlayer(i, isLocal, state, point);
                            }
                            else{
                                G.game.createWaitPlayer(i);
                            }
                            break;
                        case 3:
                            state = res["4p"].state;
                            isLocal = res["4p"].islocal;
                            point = res["4p"].point;

                            if(state >= 1){
                                G.game.createPlayer(i, isLocal, state, point);
                            }
                            else{
                                G.game.createWaitPlayer(i);
                            }
                            break;
                        default:
                            break;
                    }
                }

                // set AI's bullet limit
                G.game.bulletLimit = res.ai_bullet_limit;

                // set config data is ready flag.
                G.game.configReady = true;
            }
        });
    },

    onDisable () {
        this.unschedule(this.addSpawnCounter);
    },

    addSpawnCounter () {
        G.spawn.bossFish++;
        G.spawn.commonFish++;
                
        G.spawn.onSpawn();
    },
});
