var randFloor = require('Utils').randFloor;
var enemyType = require('Const').EnemyType;
var musicId = require('Const').MusicId;

cc.Class({
    extends: cc.Component,

    properties: {
        commonFishes: {
            default: [],
            type: [cc.Prefab]
        },
        bossFishes: {
            default: [],
            type: [cc.Prefab]
        },
        bossInterval: 30,
        randPathes: {
            default: [],
            type: [cc.AnimationClip]
        },
        seqzLeaderGroups: {
            default: [],
            type: [cc.Prefab]
        },
        seqzGroups: {
            default: [],
            type: [cc.Prefab]
        },
/*
        seqzRandGroups: {
            default: [],
            type: [cc.Prefab]
        },
*/
        fishes: cc.Node,
        seqzFishes: cc.Node,
        seqzLogic: cc.Node,
        //seqzInterval: 0,
        seqzInterval: {
            default: 1,
            visible: false
        },
        minFish: {
            default: 30,
            visible: false
        },
        maxFish: {
            default: 35,
            visible: false
        },
        commonFish: {
            default: 0,
            visible: false
        },
        seqzFish_counter: {
            default: 0,
            visible: false
        },
        bossFish: {
            default: 0,
            visible: false
        },
        seqzFish: {
            default: 0,
            visible: false
        },
        seqzFishTarget: {
            default: 0,
            visible: false
        },
        tempSP: {
            default: 0,
            visible: false
        },
        tempTP: {
            default: 0,
            visible: false
        },
        tempFishType: {
            default: 0,
            visible: false
        },
        seqPool: {
            default: [],
            visible: false
        },
    },

    // use this for initialization
    onLoad () {
        G.spawn = this;
    },

    onSpawn () {
        if((G.game.fishCount_com + G.game.fishCount_seq) < this.minFish && this.commonFish > 0){
            this.randomSpawn(0, (this.commonFishes.length-1));
        }
        else if(this.commonFish > 2 && (G.game.fishCount_com + G.game.fishCount_seq) < this.maxFish){
            this.randomSpawn(0, (this.commonFishes.length-1));
            this.commonFish = 0;
        }

        // spawn boss fish
        //if(this.bossFish > this.bossInterval && G.game.hitFish > G.game.step2 && ((G.game.fishCount_seq - G.game.fishCount_com) > 5)){
        if(this.bossFish > this.bossInterval){
            if(G.game.bossCount == 0){
                this.spawnBoss(G.game.curScene);
            }

            this.bossFish = 0;
        }

        // spawn sequence fishes
        if(G.game.hitFish > G.game.step1){
            // global sequence heart beat
            if(this.seqzFish_counter > this.seqzInterval){
                let rand = 0;
                let seqzNode = null;
                let seqzComp = null;
                let dummyNode = null;

                // leader group
                if(this.seqzLeaderGroups.length > 0){
                    //var index = -1;

                    for(let i=0; i<this.seqzLeaderGroups.length; i++){
                        //index = this.seqPool.indexOf(this.seqzLeaderGroups[i].name);
                        dummyNode = null;
                        
                        // WTF, game property will not save successfully every time. need this to notice developer.
                        if(this.seqzLeaderGroups[i] === null){
                            cc.log("seqzLeaderGroups has null object, please check.");
                        }

                        if(this.seqPool.indexOf(this.seqzLeaderGroups[i].name, 0) === -1){
                            if(G.game.fishCount_seq <= 0){
                                if(G.game.fishCount_seq < 0){
                                    // WTF, Ghost Seqfish?
                                    cc.log("onSpawn: WTF, Ghost Seqfish?");
                                    G.game.fishCount_seq = 0;
                                }

                                seqzNode = cc.instantiate(this.seqzLeaderGroups[i]);
                                seqzComp = seqzNode.getComponent('SeqSpawn');
                                seqzNode.parent = this.seqzLogic;
                                seqzComp.isLeader = true;
                                seqzNode.active = true;

                                if(seqzComp.onlyOne == true){
                                    this.seqPool.push(seqzNode.name);
                                }
                            }
                            //cc.log("onSpawn: WTF, " + this.seqzLeaderGroups[i].name + ", " + this.seqPool[0]);
                        }
                        else{
                            //dummyNode = cc.find("Canvas/SeqzFishes/" + this.seqzLeaderGroups[i].name);

                            for(let j=0; j<this.seqzLogic.children.length; j++){
                                if(this.seqzLeaderGroups[i].name == this.seqzLogic.children[j].name){
                                    dummyNode = this.seqzLogic.children[j];
                                    break;
                                }
                            }

                            if(dummyNode === null){
                                //cc.log("onSpawn: target node DNE, " + this.seqzLeaderGroups[i].name);
                                // Richard Lee: do not attach too deep, only one level now.
                                for(let m=0; m<this.seqzLogic.children.length; m++){
                                    for(let k=0; k<this.seqzLogic.children[m].children.length; k++){
                                        if(this.seqzLeaderGroups[i].name == this.seqzLogic.children[m].children[k].name){
                                            dummyNode = this.seqzLogic.children[m].children[k];
                                            break;
                                        }
                                    }
                                }
                                //dummyNode = cc.find("Canvas/SeqzFishes/seqz_logic/" + this.seqzLeaderGroups[0].name + "/" + this.seqzLeaderGroups[i].name);
                            }

                            if(dummyNode === null){
                                cc.log("onSpawn: target node DNE, " + this.seqzLeaderGroups[i].name);
                            }

                            seqzComp = dummyNode.getComponent('SeqSpawn');

                            if(seqzComp.globalInterval > 0){
                                if(seqzComp.globalCounter == 0){
                                    seqzComp.onExec();
                                }
                                
                                seqzComp.globalCounter++;

                                if(seqzComp.globalCounter >= seqzComp.globalInterval){
                                    //cc.log("WTF, " + seqzComp.globalCounter + ", " + seqzComp.globalInterval);
                                    //seqzComp.onExec();
                                    seqzComp.globalCounter = 0;
                                }
                            }
                            //cc.log("onSpawn, " + seqzComp.globalCounter);
                        }
                    }
                }

                // non-once group
                /*
                if(this.seqzGroups.length > 0){
                    rand = randFloor(0, (this.seqzGroups.length-1));
                    seqzNode = cc.instantiate(this.seqzGroups[rand]);

                    //cc.log("Spawn:onSpawn , non-once sequence group spawn, " + seqzNode);
                
                    seqzNode.parent = this.seqzFishes;
                    seqzNode.active = true;
                }
                */

                this.seqzFish_counter = 0;
            }
        }

        // update fish count
        G.game.updateFishCountText();
    },

    randomSpawn (minType, maxType) {
        let randFish = randFloor(minType, maxType);
        let fishNode = cc.instantiate(this.commonFishes[randFish]);

        fishNode.parent = this.fishes;
        fishNode.getComponent('Sheep').init = 1;
        fishNode.active = true;

        //G.game.fishCount++;
    },

    specifiedSpawn (type, path=-1) {
        let rand = path;//randFloor(0, 15);
        //var randFish = randFloor(minType, maxType);

        // for manual test
        //var rand = 10;
        let randFish = type;

        if(path < 0){
            rand = randFloor(0, (G.game.spGroups.length-1));
        }

        let fishNode = cc.instantiate(this.commonFishes[randFish]);

        fishNode.parent = this.fishes;
        fishNode.getComponent('Fish').spt = rand;
        //fishNode.target = 2;
        //fishNode.setTracer();
        fishNode.getComponent('Fish').init = 1;
        fishNode.active = true;
    },

    spawnBoss (index, path=-1) {
        //var randFish = randFloor(minType, maxType);

        // for manual test
        //var rand = 10;
        let randFish = index;

        // Richard Lee: avoid scene index > boss.count situation
        if(randFish >= this.bossFishes.length){
            randFish = 0;
        }

        let fishNode = cc.instantiate(this.bossFishes[randFish]);
        let fishComp = fishNode.getComponent('Boss');

        fishNode.parent = this.fishes;
        //fishComp.spt = rand;
        //fishNode.target = 2;
        //fishNode.setTracer();
        fishComp.init = 1;
        fishNode.active = true;

        if(fishComp.type >= enemyType.boss_1){
            G.game.bossCount++;
        }
    },

    removeSeqNode (seqNode) {
        let index = this.seqPool.indexOf(seqNode.name);

        if(index >= 0){
            cc.js.array.remove(this.seqPool, seqNode.name);
            //cc.log("removeSeqNode(A):, " + seqNode.name);
        }
        //else{
        //    cc.log("removeSeqNode(B):, " + index);
        //}
    },
});
