var randFloor = require('Utils').randFloor;
var sfxId = require('Const').SfxId;

cc.Class({
    extends: cc.Component,

    properties: {
        bullet_type1: {
            default: [],
            type: [cc.Prefab]
        },
        bulletNode: {
            default: null,
            type: cc.Node
        },
        limit: 0.33,
        isReverse: false,
        body: {
            default: [],
            type: [cc.Node]
        },
        subAni: {
            default: [],
            type: [cc.AnimationClip]
        },
        where_tips: {
            default: null,
            type: cc.Node
        },
        point_prefab: {
            default: null,
            type: cc.Prefab
        },
        point_pos: {
            default: null,
            type: cc.Node
        },
        point_text: {
            default: null,
            type: cc.RichText,
            visible: false
        },
        point: {
            default: 0,
            visible: false
        },
        direction: {
            default: cc.Vec2.ZERO,
            visible: false
        },
        limitCount: {
            default: 0,
            visible: false
        },
        seatNode: {
            default: null,
            visible: false
        },
        seatIndex: {
            default: 0,
            visible: false
        },
        isLocal: {
            default: false,
            visible: false
        },
        aiType: {
            default: 1,
            visible: false
        },
    },

    onEnable () {
        //this.schedule(this.fire, this.interval);
        this._canvas = cc.find('Canvas');
        this._commonFish = cc.find('Canvas/Fishes');
        this._seqFish = cc.find('Canvas/SeqzFishes/seqz_logic');
        //this.seatNode = this.parent;
        
        if(this.isLocal == true){
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                onTouchBegan: (touch, event) => {
                    let touchLoc = touch.getLocation();
                    let tempV1 = this._canvas.position;
                    let tempV2 = this.seatNode.position;
                    let playerLoc = this._canvas.position;

                    //cc.log("onTouch(v0): " + touchLoc.x + ", " + touchLoc.y);

                    playerLoc.x = tempV1.x + tempV2.x;
                    playerLoc.y = tempV1.y + tempV2.y;
                    this.direction.x = (touchLoc.x - playerLoc.x);
                    this.direction.y = (touchLoc.y - playerLoc.y);

                    //cc.log("onTouch: " + touchLoc.x + ", " + touchLoc.y);
                    //cc.log("onTouch(canvas): " + canvas.position.x + ", " + canvas.position.y);
                    //cc.log("onTouch(direction): " + this.direction.x + ", " + this.direction.y);
                    //cc.log("onTouch(delta): " + (touchLoc.x - playerLoc.x) + ", " + (touchLoc.y - playerLoc.y));

                    if(this.limitCount >= this.limit){
                        if(this.point > 0){
                            this.fire();
                            this.point--;
                            this.SetPoint();
                        }
                        this.limitCount = 0;
                    }

                    return true;
                    
                    /*
                    if (cc.Intersection.pointInPolygon(touchLoc, this.collider.world.points)) {
                        this.title.string = 'Hit';
                    }
                    else {
                        this.title.string = 'Not hit';
                    }
                    */
                },
            }, this.node);
        }
        else{
            this.schedule(this.simpleAI, 0.5);
        }

        // create point text
        let textNode = cc.instantiate(this.point_prefab);
        this.point_text = textNode.getComponent(cc.RichText);
        textNode.parent = this.point_pos;

        //this.SetPoint();

        if(this.isReverse == true){
            textNode.rotation = 180;
        }
    },

    update (dt) {
        this.limitCount += dt;
        //cc.log("weapon limitCount, " + this.limitCount);
    },

    onTouchStart (event) {
        //var touches = event.getTouches();
        //var delta = touches[0].getDelta();
        //this._dest.addSelf(delta);
        print("onTouchStart" + touches[0]);
    },

    onTouchEnd (event) {
        //this._dest = this.node.position;
        print("onTouchEnd" + touches[0]);
    },

    onTips: function() {
        this.unschedule(this.onTips);
        this.where_tips.active = false;
    },

    simpleAI (){
        let dummyComp = null;
        let fishLoc = null;
        let rand_common = 0;
        let rand_seq = 0;
        let rand_seq2 = 0;
        let rand_type = 10;
        let i = 0;
        let j = 0;
        let iv = 0;
        
        if(G.game.fishCount_seq > 0){
            if((G.game.fishCount_seq - G.game.fishCount_com) > 10){
               rand_type = 1; 
            }
            else{
                rand_type = randFloor(0, 20);
            }
        }
        
        if(rand_type >= 10){
            if(this._commonFish != null){
                if(this.aiType == 2){
                    // attack boss first
                    for(i=0; i<this._commonFish.children.length; i++){
                        dummyComp = this._commonFish.children[i].getComponent('Fish');

                        // try again if node type is not "fish"
                        if(dummyComp == null){
                            dummyComp = this._commonFish.children[i].getComponent('Boss');
                        }

                        //if(dummyComp.type == 1 && dummyComp.isInit >= 1){
                        if(dummyComp.isInit >= 1){
                            // AI type 2: only aiming special fish
                            if(dummyComp.type >= 20){
                                //cc.log("simpleAI: fish, " + this._commonFish.children[i].name);
                                fishLoc = this._commonFish.children[i].position;
                                iv = 1;
                                break;
                            }
                        }
                    }

                    if(iv == 0){
                        for(i=0; i<this._commonFish.children.length; i++){
                            dummyComp = this._commonFish.children[i].getComponent('Fish');

                            // try again if node type is not "fish"
                            if(dummyComp == null){
                                dummyComp = this._commonFish.children[i].getComponent('Boss');
                            }

                            if(dummyComp.isInit >= 1){
                                // AI type 2: only aiming special fish
                                if(dummyComp.type < 2){
                                    continue;
                                }

                                fishLoc = this._commonFish.children[i].position;
                                break;
                            }
                        }
                    }
                }
                else{
                    if(this._commonFish.children.length > 1 && this.aiType < 2){
                        rand_common = randFloor(0, (this._commonFish.children.length-1));
                    }

                    for(i=rand_common; i<this._commonFish.children.length; i++){
                        dummyComp = this._commonFish.children[i].getComponent('Fish');

                        // try again if node type is not "fish"
                        if(dummyComp == null){
                            dummyComp = this._commonFish.children[i].getComponent('Boss');
                        }

                        //if(dummyComp.type == 1 && dummyComp.isInit >= 1){
                        if(dummyComp.isInit >= 1){
                            //fishLoc = this._commonFish.children[i].convertToNodeSpace(this._commonFish.children[i].position);
                            fishLoc = this._commonFish.children[i].position;
                            //cc.log("simpleAI: fish, " + this.commonFish.children[i].name);
                            break;
                        }
                    }
                }
            }
        }
        else{
            if(this._seqFish != null){
                if(this._seqFish.children.length > 1){
                    rand_seq = randFloor(0, (this._seqFish.children.length-1));
                }

                //cc.log("simpleAI: seq fish 2, " + rand_seq + ", " + this._seqFish.children.length);

                for(i=rand_seq; i<this._seqFish.children.length; i++){
                    dummyComp = this._seqFish.children[i].getComponent('SeqFish');

                    if(this._seqFish.children[i].children.length > 0){
                        //cc.log("simpleAI: seq fish 1, " + this._seqFish.children[i].children.length);
                        if(this._seqFish.children[i].children.length > 1){
                            rand_seq2 = randFloor(0, (this._seqFish.children[i].children.length-1));
                        }

                        for(j=rand_seq2; j<this._seqFish.children[i].children.length; j++){
                            dummyComp = this._seqFish.children[i].children[j].getComponent('SeqFish');

                            if(dummyComp == null){
                                continue;
                            }

                            if(dummyComp.isInit >= 1 && dummyComp.isDummy == false){
                                // AI type 2: only aiming special fish
                                if(this.aiType == 2 && dummyComp.type < 12){
                                    break;
                                }

                                fishLoc = this._seqFish.children[i].children[j].position;
                                dummyComp = null;
                                //cc.log("simpleAI: seq fish, " + this._seqFish.children[i].name);
                                break;
                            }
                        }
                    }

                    if(dummyComp == null){
                        continue;
                    }

                    //cc.log("simpleAI: seq fish 2, " + i + ", " + this._seqFish.children[i].name);

                    //if(dummyComp.type == 1 && dummyComp.isInit >= 1){
                    if(dummyComp.isInit >= 1 && dummyComp.isDummy == false){
                        //fishLoc = this._commonFish.children[i].convertToNodeSpace(this._commonFish.children[i].position);
                        fishLoc = this._seqFish.children[i].position;
                        //cc.log("simpleAI: seq fish, " + this._seqFish.children[i].name);
                        break;
                    }
                }
            }
        }

        if(fishLoc != null){
            let tempV1 = this._canvas.position;
            let tempV2 = this.seatNode.position;
            let playerLoc = this._canvas.position;
            //let playerLoc = this.node.convertToWorldSpace(cc.Vec2.ZERO);

            //cc.log("simpleAI(0): " + fishLoc.x + ", " + fishLoc.y);
            //cc.log("simpleAI(1): " + playerLoc.x + ", " + playerLoc.y);

            playerLoc.x = tempV1.x + tempV2.x;
            playerLoc.y = tempV1.y + tempV2.y;
            fishLoc.x += tempV1.x;
            fishLoc.y += tempV1.y;
            this.direction.x = (fishLoc.x - playerLoc.x);
            this.direction.y = (fishLoc.y - playerLoc.y);

            //cc.log("simpleAI(1): " + this.direction.x + ", " + this.direction.y);

            if(this.point > 0){
                this.fire();
                this.point--;
                this.SetPoint();
            }
        }
    },

    play_animation: function(index=-1) {
        if(this.body.length == 0){
            return;
        }

        let animBody;

        if(index >= 0){
            animBody = this.body[index].getComponent(cc.Animation);
            animBody.playAdditive(this.subAni[index].name);
        }
        else{
            for(let i=0; i < this.body.length; i++){
                animBody = this.body[i].getComponent(cc.Animation);
                animBody.playAdditive(this.subAni[i].name);
            }
        }
    },

    SetPoint: function(val=-1) {

        if(val >= 0){
            this.point = val;
        }

        if(this.point >= 100){
            this.point_text.string = "<color=#ffffff>" + this.point + "</c>";
        }
        else{
            this.point_text.string = "<color=#ff0000>" + this.point + "</c>"; 
        }
    },

    AddPoint: function(val=1) {

        if(val >= 0){
            this.point += val;
        }

        if(this.point >= 100){
            this.point_text.string = "<color=#ffffff>" + this.point + "</c>";
        }
        else{
            this.point_text.string = "<color=#ff0000>" + this.point + "</c>"; 
        }
    },

    fire () {
        // check direction legal
        let position = this.node.convertToWorldSpaceAR(cc.Vec2.ZERO);
        let angle = Math.atan2(this.direction.y, this.direction.x);
        let degree = angle;
        let v0 = new cc.v2(-position.x, -position.y);
        let v1 = new cc.v2((G.game.screenSize.x-position.x), -position.y);
        let dot0 = 0;
        let dot1 = 0;
        let angValue0 = 0;
        let angValue1 = 0;
        let plus = 0;

        // for AI's bullet limit
        if(this.isLocal == false){
            if(G.game.bulletCount > G.game.bulletLimit){
                //cc.log("AI's bullet= " + G.game.bulletCount);
                return;
            }

            G.game.bulletCount++;
        }

        // play shoot animation
        //this.play_animation();

        if(this.isReverse){
            v0.y = (G.game.screenSize.y-position.y);
            v1.y = (G.game.screenSize.y-position.y);
            dot0 = v0.dot(this.direction);
            dot1 = v1.dot(this.direction);
            angValue0 = dot0 / (v0.mag() * this.direction.mag());
            angValue1 = dot1 / (v1.mag() * this.direction.mag());

            if(angValue0 > 0.95){
                //cc.log("bullet angle(A)= " + angValue0 + ", " + degree + ", " + direction.x + ", " + direction.y);
                this.direction.x = -4.456;
                this.direction.y = -1;
                degree = -2.8239;
                plus = -0.1;
            }
            else if(angValue1 > 0.95){
                //cc.log("bullet angle(B)= " + angValue1 + ", " + degree + ", " + direction.x + ", " + direction.y);
                this.direction.x = 4.456;
                this.direction.y = -1;
                degree = -0.3177;
                plus = 0.1;
            }
            else if(this.direction.y > 0){
                //cc.log("bullet angle(C)= " + angValue + ", " + degree + ", " + direction.x + ", " + direction.y);
                if(this.direction.x >= 0){
                    this.direction.x = 4.456;
                    this.direction.y = -1;
                    degree = -0.3177;
                    plus = 0.1;
                }
                else{
                    this.direction.x = -4.456;
                    this.direction.y = -1;
                    degree = -2.8239;
                    plus = -0.1;
                }
            }
        }
        else{
            dot0 = v0.dot(this.direction);
            dot1 = v1.dot(this.direction);
            angValue0 = dot0 / (v0.mag() * this.direction.mag());
            angValue1 = dot1 / (v1.mag() * this.direction.mag());

            if(angValue0 > 0.95){
                //cc.log("bullet angle(A)= " + angValue0 + ", " + degree + ", " + direction.x + ", " + direction.y);
                this.direction.x = -4.456;
                this.direction.y = 1;
                degree = 2.8239;
                plus = 0.1;
            }
            else if(angValue1 > 0.95){
                //cc.log("bullet angle(B)= " + angValue1 + ", " + degree + ", " + direction.x + ", " + direction.y);
                this.direction.x = 4.456;
                this.direction.y = 1;
                degree = 0.3177;
                plus = -0.1;
            }
            else if(this.direction.y < 0){
                //cc.log("bullet angle(C)= " + angValue + ", " + degree + ", " + direction.x + ", " + direction.y);
                if(this.direction.x >= 0){
                    this.direction.x = 4.456;
                    this.direction.y = 1;
                    degree = 0.3177;
                    plus = -0.1;
                }
                else{
                    this.direction.x = -4.456;
                    this.direction.y = 1;
                    degree = 2.8239;
                    plus = 0.1;
                }
            }
        }

        degree += plus;
        degree = degree * 180 / Math.PI;

        if(this.isReverse){
            this.node.rotation = 270 - degree;
        }
        else{
            this.node.rotation = 90 - degree;
        }

        G.bullets.add(this.seatIndex, this.bullet_type1[this.seatIndex], this.bulletNode.convertToWorldSpaceAR(cc.Vec2.ZERO), this.direction, degree);
    }
});
